<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/ft_menu_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>03/19/85  ft_menu_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>The ft_menu_ subroutine allows a FORTRAN program to use the Multics
<span id="L5" class="LineNr">  5 </span>menu facility <span class="textRainbow_lv0_p0">(</span>menu_<span class="textRainbow_lv0_p0">)</span>.  Through ft_menu_ a FORTRAN program may create a
<span id="L6" class="LineNr">  6 </span>menu object, display the menu, and get a user-entered selection from a
<span id="L7" class="LineNr">  7 </span>menu.  Once a menu object has been created, the FORTRAN program can use
<span id="L8" class="LineNr">  8 </span>this menu object by referencing it via a menu-id returned to the caller
<span id="L9" class="LineNr">  9 </span>when the menu object was created or when a stored menu object was
<span id="L10" class="LineNr"> 10 </span>retrieved.
<span id="L11" class="LineNr"> 11 </span>
<span id="L12" class="LineNr"> 12 </span>The functionality available is provided through the various entry
<span id="L13" class="LineNr"> 13 </span>points defined below.
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>Entry points in ft_menu_:
<span id="L17" class="LineNr"> 17 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L18" class="LineNr"> 18 </span>
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>:Entry:  create:  03/19/85 ft_menu_$create
<span id="L21" class="LineNr"> 21 </span>
<span id="L22" class="LineNr"> 22 </span>
<span id="L23" class="LineNr"> 23 </span>Function:  Utilized to create a menu object.  It returns a menu
<span id="L24" class="LineNr"> 24 </span>identifier <span class="textRainbow_lv0_p0">(</span>menu_id<span class="textRainbow_lv0_p0">)</span> which is subsequently used to reference the menu
<span id="L25" class="LineNr"> 25 </span>object.
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>
<span id="L28" class="LineNr"> 28 </span>Syntax:
<span id="L29" class="LineNr"> 29 </span>   declarations:
<span id="L30" class="LineNr"> 30 </span>     character*n1  choices<span class="textRainbow_lv0_p0">(</span>m1<span class="textRainbow_lv0_p0">)</span>
<span id="L31" class="LineNr"> 31 </span>     character*n2  headers<span class="textRainbow_lv0_p0">(</span>m2<span class="textRainbow_lv0_p0">)</span>
<span id="L32" class="LineNr"> 32 </span>     character*n3  trailers<span class="textRainbow_lv0_p0">(</span>m3<span class="textRainbow_lv0_p0">)</span>
<span id="L33" class="LineNr"> 33 </span>     character*1   keys<span class="textRainbow_lv0_p0">(</span>m4<span class="textRainbow_lv0_p0">)</span>
<span id="L34" class="LineNr"> 34 </span>     character*1   pad_char
<span id="L35" class="LineNr"> 35 </span>     integer       menu_format<span class="textRainbow_lv0_p0">(</span>6<span class="textRainbow_lv0_p0">)</span>
<span id="L36" class="LineNr"> 36 </span>     integer       menu_needs<span class="textRainbow_lv0_p0">(</span>3<span class="textRainbow_lv0_p0">)</span>
<span id="L37" class="LineNr"> 37 </span>     integer       menu_id
<span id="L38" class="LineNr"> 38 </span>     integer       code
<span id="L39" class="LineNr"> 39 </span>call ft_menu_$create <span class="textRainbow_lv0_p0">(</span>choices<span class="textRainbow_lv0_o0">,</span> headers<span class="textRainbow_lv0_o0">,</span> trailers<span class="textRainbow_lv0_o0">,</span> pad_char<span class="textRainbow_lv0_o0">,</span>
<span id="L40" class="LineNr"> 40 </span>     menu_format<span class="textRainbow_lv0_o0">,</span> key<span class="textRainbow_lv0_o0">,</span> menu_needs<span class="textRainbow_lv0_o0">,</span> menu_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>
<span id="L41" class="LineNr"> 41 </span>
<span id="L42" class="LineNr"> 42 </span>
<span id="L43" class="LineNr"> 43 </span>Arguments:
<span id="L44" class="LineNr"> 44 </span>choices
<span id="L45" class="LineNr"> 45 </span>   is an array of character variables which are the text of the options
<span id="L46" class="LineNr"> 46 </span>   that  the user  wishes to  display in the  menu.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>  n1 is the
<span id="L47" class="LineNr"> 47 </span>   length,  in characters,  of the longest  character string comprising
<span id="L48" class="LineNr"> 48 </span>   the text  of an option.   m1 is the  extent of the  array, i.e., the
<span id="L49" class="LineNr"> 49 </span>   number of options  in the menu being described.   This array must be
<span id="L50" class="LineNr"> 50 </span>   at least of extent 1.
<span id="L51" class="LineNr"> 51 </span>headers
<span id="L52" class="LineNr"> 52 </span>   is an array of character variables to be displayed at the top of the
<span id="L53" class="LineNr"> 53 </span>   menu.   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>  n2 is  the  length, in  characters, of  the longest
<span id="L54" class="LineNr"> 54 </span>   header specified.  m2  is the extent of the  array, i.e., the number
<span id="L55" class="LineNr"> 55 </span>   of headers <span class="textRainbow_lv0_p0">(</span>lines<span class="textRainbow_lv0_p0">)</span>  desired.  At least one header  must be specified
<span id="L56" class="LineNr"> 56 </span>   <span class="textRainbow_lv0_p0">(</span>if the first variable is set to blanks<span class="textRainbow_lv0_o0">,</span> no headers will be used<span class="textRainbow_lv0_p0">)</span>.
<span id="L57" class="LineNr"> 57 </span>
<span id="L58" class="LineNr"> 58 </span>
<span id="L59" class="LineNr"> 59 </span>trailers
<span id="L60" class="LineNr"> 60 </span>   is  an  array of  trailers <span class="textRainbow_lv0_p0">(</span>displayed  immediately below  the menu<span class="textRainbow_lv0_p0">)</span>.
<span id="L61" class="LineNr"> 61 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> n3, m3, are analogous to n2, m2 respectively.
<span id="L62" class="LineNr"> 62 </span>menu_format
<span id="L63" class="LineNr"> 63 </span>   is an array,  which specifies the format of  the menu being created.
<span id="L64" class="LineNr"> 64 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> Prior to calling this entry point, the FORTRAN programmer is
<span id="L65" class="LineNr"> 65 </span>   responsible for setting the following variables:
<span id="L66" class="LineNr"> 66 </span>      menu_format<span class="textRainbow_lv0_p0">(</span>menu_version<span class="textRainbow_lv0_p0">)</span> = version number of menu_
<span id="L67" class="LineNr"> 67 </span>              <span class="textRainbow_lv0_p0">(</span>currently<span class="textRainbow_lv0_o0">,</span> only version 1 is defined<span class="textRainbow_lv0_p0">)</span>.
<span id="L68" class="LineNr"> 68 </span>      menu_format<span class="textRainbow_lv0_p0">(</span>max_width<span class="textRainbow_lv0_p0">)</span> = maximum width of the window
<span id="L69" class="LineNr"> 69 </span>               on which the menu will be displayed.
<span id="L70" class="LineNr"> 70 </span>      menu_format<span class="textRainbow_lv0_p0">(</span>max_heigth<span class="textRainbow_lv0_p0">)</span> = maximum height of window
<span id="L71" class="LineNr"> 71 </span>                on which menu is to be displayed.
<span id="L72" class="LineNr"> 72 </span>      menu_format<span class="textRainbow_lv0_p0">(</span>no_of_columns<span class="textRainbow_lv0_p0">)</span> = number of columns to be used
<span id="L73" class="LineNr"> 73 </span>                by the menu manager to display the options.
<span id="L74" class="LineNr"> 74 </span>      menu_format<span class="textRainbow_lv0_p0">(</span>center_headers<span class="textRainbow_lv0_p0">)</span> = 0 or 1;  0 = no, 1 = yes.
<span id="L75" class="LineNr"> 75 </span>      menu_format<span class="textRainbow_lv0_p0">(</span>center_trailers<span class="textRainbow_lv0_p0">)</span> = 0 or 1;  0 = no, 1 = yes.
<span id="L76" class="LineNr"> 76 </span>
<span id="L77" class="LineNr"> 77 </span>
<span id="L78" class="LineNr"> 78 </span>pad_char
<span id="L79" class="LineNr"> 79 </span>   is the  character that the  menu facility will display  at the right
<span id="L80" class="LineNr"> 80 </span>   and  left of  a centered  header or  trailer to  fill out  the line.
<span id="L81" class="LineNr"> 81 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L82" class="LineNr"> 82 </span>keys
<span id="L83" class="LineNr"> 83 </span>   is  an  array  <span class="textRainbow_lv0_p0">(</span>maximum  value  of m4  is  61<span class="textRainbow_lv0_p0">)</span>  that  identifies the
<span id="L84" class="LineNr"> 84 </span>   keystroke  to be  associated with  each choice.   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> This array
<span id="L85" class="LineNr"> 85 </span>   must be at least as long as the number of choices in the menu.  Each
<span id="L86" class="LineNr"> 86 </span>   element in the array must be unique.
<span id="L87" class="LineNr"> 87 </span>menu_needs
<span id="L88" class="LineNr"> 88 </span>   an  array  that  contains  menu  related  information  on successful
<span id="L89" class="LineNr"> 89 </span>   execution of call.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>
<span id="L92" class="LineNr"> 92 </span>      Returned information:
<span id="L93" class="LineNr"> 93 </span>
<span id="L94" class="LineNr"> 94 </span>      menu_needs<span class="textRainbow_lv0_p0">(</span>lines_needed<span class="textRainbow_lv0_p0">)</span>  the number of lines required
<span id="L95" class="LineNr"> 95 </span>                                to display the menu.
<span id="L96" class="LineNr"> 96 </span>      menu_needs<span class="textRainbow_lv0_p0">(</span>width_needed<span class="textRainbow_lv0_p0">)</span>  the number of columns required
<span id="L97" class="LineNr"> 97 </span>                                to display the menu.
<span id="L98" class="LineNr"> 98 </span>      menu_needs<span class="textRainbow_lv0_p0">(</span>no_of_options<span class="textRainbow_lv0_p0">)</span> the number of options defined
<span id="L99" class="LineNr"> 99 </span>                                in the menu.
<span id="L100" class="LineNr">100 </span>
<span id="L101" class="LineNr">101 </span>
<span id="L102" class="LineNr">102 </span>menu_id
<span id="L103" class="LineNr">103 </span>   the menu identifier <span class="textRainbow_lv0_p0">(</span>i.e.<span class="textRainbow_lv0_o0">,</span>  the menu object &quot;identifier&quot;<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L104" class="LineNr">104 </span>   It must not be altered in any way by the application program.
<span id="L105" class="LineNr">105 </span>code
<span id="L106" class="LineNr">106 </span>   return code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L107" class="LineNr">107 </span>
<span id="L108" class="LineNr">108 </span>
<span id="L109" class="LineNr">109 </span>:Entry:  delete:  03/19/85 ft_menu_$delete
<span id="L110" class="LineNr">110 </span>
<span id="L111" class="LineNr">111 </span>
<span id="L112" class="LineNr">112 </span>Function:   Deletes a  menu object  from a  given value  segment.  <span class="textRainbow_lv0_p0">(</span>See
<span id="L113" class="LineNr">113 </span>ft_menu_$store.<span class="textRainbow_lv0_p0">)</span>
<span id="L114" class="LineNr">114 </span>
<span id="L115" class="LineNr">115 </span>
<span id="L116" class="LineNr">116 </span>Syntax:
<span id="L117" class="LineNr">117 </span>   declarations:
<span id="L118" class="LineNr">118 </span>     character*168  dir_name
<span id="L119" class="LineNr">119 </span>     character*32   entry_name
<span id="L120" class="LineNr">120 </span>     character*32   menu_name
<span id="L121" class="LineNr">121 </span>     integer        code
<span id="L122" class="LineNr">122 </span>   call ft_menu_$delete <span class="textRainbow_lv0_p0">(</span>dir_name<span class="textRainbow_lv0_o0">,</span> entry_name<span class="textRainbow_lv0_o0">,</span> menu_name<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>
<span id="L123" class="LineNr">123 </span>
<span id="L124" class="LineNr">124 </span>
<span id="L125" class="LineNr">125 </span>Arguments:
<span id="L126" class="LineNr">126 </span>dir_name
<span id="L127" class="LineNr">127 </span>   pathname of the directory containing the menu object.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L128" class="LineNr">128 </span>entry_name
<span id="L129" class="LineNr">129 </span>   entry name of value segment containing the menu object.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The
<span id="L130" class="LineNr">130 </span>   suffix &quot;value&quot; need not be specified.
<span id="L131" class="LineNr">131 </span>menu_name
<span id="L132" class="LineNr">132 </span>   name  used  to identify  the menu  object when  the menu  object was
<span id="L133" class="LineNr">133 </span>   stored.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L134" class="LineNr">134 </span>code
<span id="L135" class="LineNr">135 </span>   return code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L136" class="LineNr">136 </span>
<span id="L137" class="LineNr">137 </span>
<span id="L138" class="LineNr">138 </span>:Entry:  describe:  03/19/85 ft_menu_$describe
<span id="L139" class="LineNr">139 </span>
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>Function:   Returns information  about a  menu object.   It returns the
<span id="L142" class="LineNr">142 </span>number  of  options in  the menu,  the  number of  lines and  number of
<span id="L143" class="LineNr">143 </span>columns  required  to  display  the  menu.   It  is  primarily  used to
<span id="L144" class="LineNr">144 </span>determine if the menu can be displayed in a given window.
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>
<span id="L147" class="LineNr">147 </span>Syntax:
<span id="L148" class="LineNr">148 </span>   declarations:
<span id="L149" class="LineNr">149 </span>     integer  menu_id
<span id="L150" class="LineNr">150 </span>     integer  menu_needs<span class="textRainbow_lv0_p0">(</span>3<span class="textRainbow_lv0_p0">)</span>
<span id="L151" class="LineNr">151 </span>     integer  code
<span id="L152" class="LineNr">152 </span>   call ft_menu_$describe <span class="textRainbow_lv0_p0">(</span>menu_id<span class="textRainbow_lv0_o0">,</span> menu_needs<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>
<span id="L153" class="LineNr">153 </span>
<span id="L154" class="LineNr">154 </span>
<span id="L155" class="LineNr">155 </span>
<span id="L156" class="LineNr">156 </span>Arguments:
<span id="L157" class="LineNr">157 </span>menu_id
<span id="L158" class="LineNr">158 </span>   the    menu    identifier    returned    by    ft_menu_$create    or
<span id="L159" class="LineNr">159 </span>   ft_menu_$retrieve.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L160" class="LineNr">160 </span>menu_needs
<span id="L161" class="LineNr">161 </span>   an array into which menu related information is returned.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L162" class="LineNr">162 </span>
<span id="L163" class="LineNr">163 </span>
<span id="L164" class="LineNr">164 </span>      Returned information:
<span id="L165" class="LineNr">165 </span>      menu_needs<span class="textRainbow_lv0_p0">(</span>lines_needed<span class="textRainbow_lv0_p0">)</span>       the number of lines required
<span id="L166" class="LineNr">166 </span>                                     to display the menu.
<span id="L167" class="LineNr">167 </span>
<span id="L168" class="LineNr">168 </span>      menu_needs<span class="textRainbow_lv0_p0">(</span>width_needed<span class="textRainbow_lv0_p0">)</span>       the number of columns needed
<span id="L169" class="LineNr">169 </span>                                     to display the menu.
<span id="L170" class="LineNr">170 </span>
<span id="L171" class="LineNr">171 </span>      menu_needs<span class="textRainbow_lv0_p0">(</span>no_of_options<span class="textRainbow_lv0_p0">)</span>      the number of options defined
<span id="L172" class="LineNr">172 </span>                                     in the menu.
<span id="L173" class="LineNr">173 </span>code
<span id="L174" class="LineNr">174 </span>   return code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L175" class="LineNr">175 </span>
<span id="L176" class="LineNr">176 </span>
<span id="L177" class="LineNr">177 </span>:Entry:  destroy:  03/19/85 ft_menu_$destroy
<span id="L178" class="LineNr">178 </span>
<span id="L179" class="LineNr">179 </span>
<span id="L180" class="LineNr">180 </span>Function:  Invoked  to delete a  menu object from storage.   <span class="textRainbow_lv0_p0">(</span>Not to be
<span id="L181" class="LineNr">181 </span>confused  with ft_menu_$delete<span class="textRainbow_lv0_o0">,</span>  which deletes  the menu  object from a
<span id="L182" class="LineNr">182 </span>value segment.<span class="textRainbow_lv0_p0">)</span>  Deleting  the menu object has no  effect on the screen
<span id="L183" class="LineNr">183 </span>contents.
<span id="L184" class="LineNr">184 </span>
<span id="L185" class="LineNr">185 </span>
<span id="L186" class="LineNr">186 </span>Syntax:
<span id="L187" class="LineNr">187 </span>   declarations:
<span id="L188" class="LineNr">188 </span>     integer  menu_id
<span id="L189" class="LineNr">189 </span>     integer  code
<span id="L190" class="LineNr">190 </span>   call ft_menu_$destroy <span class="textRainbow_lv0_p0">(</span>menu_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L191" class="LineNr">191 </span>
<span id="L192" class="LineNr">192 </span>
<span id="L193" class="LineNr">193 </span>
<span id="L194" class="LineNr">194 </span>Arguments:
<span id="L195" class="LineNr">195 </span>menu_id
<span id="L196" class="LineNr">196 </span>   menu  identifier returned  by ft_menu_$create  or ft_menu_$retrieve.
<span id="L197" class="LineNr">197 </span>   <span class="textRainbow_lv0_p0">(</span>Input/Output<span class="textRainbow_lv0_p0">)</span> Set to an invalid value  on return to prevent the old
<span id="L198" class="LineNr">198 </span>   menu_id from being accidentally used.
<span id="L199" class="LineNr">199 </span>code
<span id="L200" class="LineNr">200 </span>   return code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L201" class="LineNr">201 </span>
<span id="L202" class="LineNr">202 </span>
<span id="L203" class="LineNr">203 </span>:Entry:  display:  03/19/85 ft_menu_$display
<span id="L204" class="LineNr">204 </span>
<span id="L205" class="LineNr">205 </span>
<span id="L206" class="LineNr">206 </span>Function:  Invoked to display a menu in a given window.
<span id="L207" class="LineNr">207 </span>
<span id="L208" class="LineNr">208 </span>
<span id="L209" class="LineNr">209 </span>Syntax:
<span id="L210" class="LineNr">210 </span>   declarations:
<span id="L211" class="LineNr">211 </span>     integer  window_id
<span id="L212" class="LineNr">212 </span>     integer  menu_id
<span id="L213" class="LineNr">213 </span>     integer  code
<span id="L214" class="LineNr">214 </span>   call ft_menu_$display <span class="textRainbow_lv0_p0">(</span>window_id<span class="textRainbow_lv0_o0">,</span> menu_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>
<span id="L215" class="LineNr">215 </span>
<span id="L216" class="LineNr">216 </span>
<span id="L217" class="LineNr">217 </span>Arguments:
<span id="L218" class="LineNr">218 </span>window_id
<span id="L219" class="LineNr">219 </span>   a  window  identifier  returned  by  ft_window_$create.   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If
<span id="L220" class="LineNr">220 </span>   usage_mode = 0 this argument will be ignored <span class="textRainbow_lv0_p0">(</span>see ft_menu_$init2<span class="textRainbow_lv0_p0">)</span>.
<span id="L221" class="LineNr">221 </span>menu_id
<span id="L222" class="LineNr">222 </span>   menu  identifier  returned  when  the  menu  object  was  created or
<span id="L223" class="LineNr">223 </span>   retrieved.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L224" class="LineNr">224 </span>code
<span id="L225" class="LineNr">225 </span>   return code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L226" class="LineNr">226 </span>
<span id="L227" class="LineNr">227 </span>
<span id="L228" class="LineNr">228 </span>:Entry:  get_choice:  03/19/85 ft_menu_$get_choice
<span id="L229" class="LineNr">229 </span>
<span id="L230" class="LineNr">230 </span>
<span id="L231" class="LineNr">231 </span>Function:   Returns  the  choice made  by  the user,  i.e.,  an integer
<span id="L232" class="LineNr">232 </span>representing either  the menu item  chosen or the function  key <span class="textRainbow_lv0_p0">(</span>or its
<span id="L233" class="LineNr">233 </span>equivalent escape sequence<span class="textRainbow_lv0_p0">)</span> entered.
<span id="L234" class="LineNr">234 </span>
<span id="L235" class="LineNr">235 </span>
<span id="L236" class="LineNr">236 </span>Syntax:
<span id="L237" class="LineNr">237 </span>   declarations:
<span id="L238" class="LineNr">238 </span>     character*n1  function_key_info
<span id="L239" class="LineNr">239 </span>     integer       window_id
<span id="L240" class="LineNr">240 </span>     integer       menu_id
<span id="L241" class="LineNr">241 </span>     integer       fkeys
<span id="L242" class="LineNr">242 </span>     integer       selection
<span id="L243" class="LineNr">243 </span>     integer       code
<span id="L244" class="LineNr">244 </span>   call ft_menu_$get_choice <span class="textRainbow_lv0_p0">(</span>window_id<span class="textRainbow_lv0_o0">,</span> menu_id<span class="textRainbow_lv0_o0">,</span> function_key_info<span class="textRainbow_lv0_o0">,</span>
<span id="L245" class="LineNr">245 </span>          fkeys<span class="textRainbow_lv0_o0">,</span> selection<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>
<span id="L246" class="LineNr">246 </span>
<span id="L247" class="LineNr">247 </span>
<span id="L248" class="LineNr">248 </span>Arguments:
<span id="L249" class="LineNr">249 </span>window_id
<span id="L250" class="LineNr">250 </span>   a  window  identifier  returned  by  ft_window_$create.   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If
<span id="L251" class="LineNr">251 </span>   usage_mode = 0 this argument will be ignored.  <span class="textRainbow_lv0_p0">(</span>see ft_menu_$init2<span class="textRainbow_lv0_p0">)</span>
<span id="L252" class="LineNr">252 </span>menu_id
<span id="L253" class="LineNr">253 </span>   menu  identifier returned  by ft_menu_$create  or ft_menu_$retrieve.
<span id="L254" class="LineNr">254 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L255" class="LineNr">255 </span>
<span id="L256" class="LineNr">256 </span>
<span id="L257" class="LineNr">257 </span>function_key_info
<span id="L258" class="LineNr">258 </span>   a character  variable <span class="textRainbow_lv0_p0">(</span>n1 as  required<span class="textRainbow_lv0_p0">)</span> used to specify  the role of
<span id="L259" class="LineNr">259 </span>   function  keys <span class="textRainbow_lv0_p0">(</span>if  they exist  for the  terminal being  used<span class="textRainbow_lv0_p0">)</span> or an
<span id="L260" class="LineNr">260 </span>   equivalent  set of  escape sequences if  the terminal  does not have
<span id="L261" class="LineNr">261 </span>   function keys or not the  function keys required by the application.
<span id="L262" class="LineNr">262 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The objective  is to let the application  use the terminal's
<span id="L263" class="LineNr">263 </span>   function keys if possible, else specify  key sequences to be used to
<span id="L264" class="LineNr">264 </span>   simulate function keys.  Each character in the string corresponds to
<span id="L265" class="LineNr">265 </span>   one  function key.   If the  character is  a space,  then it  is not
<span id="L266" class="LineNr">266 </span>   relevant if  the corresponding function  key exists or  not.  If the
<span id="L267" class="LineNr">267 </span>   character is not a space, that  character will be used to simulate a
<span id="L268" class="LineNr">268 </span>   function key  if the terminal  does not have function  keys.  If the
<span id="L269" class="LineNr">269 </span>   terminal does not have a  function key for every non-space character
<span id="L270" class="LineNr">270 </span>   in  the string,  then function  keys will  be simulated.   Thus, the
<span id="L271" class="LineNr">271 </span>   string  &quot; ?p  q&quot; means  that the  caller does  not care  whether the
<span id="L272" class="LineNr">272 </span>   terminal has  function key 0 or  3, but the caller  does wish to use
<span id="L273" class="LineNr">273 </span>   function keys  1,2, and 4.  If  any of these 3  function keys is not
<span id="L274" class="LineNr">274 </span>   present on the  terminal, then esc-?  will substitute  for F1, esc-p
<span id="L275" class="LineNr">275 </span>   will substitute for F2, and esc-q will substitute for F4.
<span id="L276" class="LineNr">276 </span>
<span id="L277" class="LineNr">277 </span>
<span id="L278" class="LineNr">278 </span>fkeys
<span id="L279" class="LineNr">279 </span>   if fkeys = 1 user entered a function key or escape sequence if fkeys
<span id="L280" class="LineNr">280 </span>   = 0 user selected an option <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L281" class="LineNr">281 </span>selection
<span id="L282" class="LineNr">282 </span>   is an integer representing the choice made by the user.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> If
<span id="L283" class="LineNr">283 </span>   the  user has  chosen an option,  it is  a number between  1 and the
<span id="L284" class="LineNr">284 </span>   highest defined option.  If the user  has entered a function key, or
<span id="L285" class="LineNr">285 </span>   escape  sequence  simulating  a  function  key,  it  is  the  number
<span id="L286" class="LineNr">286 </span>   associated with the function key.
<span id="L287" class="LineNr">287 </span>code
<span id="L288" class="LineNr">288 </span>   return code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L289" class="LineNr">289 </span>
<span id="L290" class="LineNr">290 </span>
<span id="L291" class="LineNr">291 </span>:Entry:  init1:  init2:  03/19/85 ft_menu_$init1, ft_menu_$init2
<span id="L292" class="LineNr">292 </span>
<span id="L293" class="LineNr">293 </span>
<span id="L294" class="LineNr">294 </span>Function:   These must  be the  first calls  made to  the menu manager.
<span id="L295" class="LineNr">295 </span>They  set up  the necessary  environment for  the menu  application and
<span id="L296" class="LineNr">296 </span>return information concerning the user i/o window.
<span id="L297" class="LineNr">297 </span>
<span id="L298" class="LineNr">298 </span>
<span id="L299" class="LineNr">299 </span>Syntax:
<span id="L300" class="LineNr">300 </span>   declarations:
<span id="L301" class="LineNr">301 </span>     integer   code
<span id="L302" class="LineNr">302 </span>     integer   usage_mode
<span id="L303" class="LineNr">303 </span>   call ft_menu_$init1 <span class="textRainbow_lv0_p0">()</span>
<span id="L304" class="LineNr">304 </span>   call ft_menu_$init2
<span id="L305" class="LineNr">305 </span>        <span class="textRainbow_lv0_p0">(</span>usage_mode<span class="textRainbow_lv0_o0">,</span>user_window_lines<span class="textRainbow_lv0_o0">,</span>user_window_columns<span class="textRainbow_lv0_o0">,</span>
<span id="L306" class="LineNr">306 </span>        user_window_id<span class="textRainbow_lv0_o0">,</span>code<span class="textRainbow_lv0_p0">)</span>
<span id="L307" class="LineNr">307 </span>
<span id="L308" class="LineNr">308 </span>
<span id="L309" class="LineNr">309 </span>Arguments:
<span id="L310" class="LineNr">310 </span>usage_mode
<span id="L311" class="LineNr">311 </span>   usage_mode = 0 means that the caller  does not wish to do any window
<span id="L312" class="LineNr">312 </span>   management at  all.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> When  he/she wishes to  display a menu,
<span id="L313" class="LineNr">313 </span>   the window required will be  automatically created.  This means that
<span id="L314" class="LineNr">314 </span>   the  application  will  operate in  a  two window  mode,  the window
<span id="L315" class="LineNr">315 </span>   containing the menu,  and the user_io window.  Both  windows will be
<span id="L316" class="LineNr">316 </span>   managed  automatically  for the  user.  If  the user  specifies this
<span id="L317" class="LineNr">317 </span>   mode,  all calls  to the ft_window_  subroutine will  be ignored and
<span id="L318" class="LineNr">318 </span>   will  return  an appropriate  error code.
<span id="L319" class="LineNr">319 </span>   All  calls to  the ft_menu_  subroutine that
<span id="L320" class="LineNr">320 </span>   require a window identifier will ignore the user provided window_id.
<span id="L321" class="LineNr">321 </span>   usage_mode = 1  means that the user wishes to  define the number and
<span id="L322" class="LineNr">322 </span>   characteristics of the windows to be used in the application.  Thus,
<span id="L323" class="LineNr">323 </span>   calls to ft_window_  will be supported and, for  the entry points of
<span id="L324" class="LineNr">324 </span>   ft_menu_  that require  a window identifier,  the caller  must use a
<span id="L325" class="LineNr">325 </span>   legal window_id <span class="textRainbow_lv0_p0">(</span>returned by ft_window_$create<span class="textRainbow_lv0_p0">)</span>.
<span id="L326" class="LineNr">326 </span>
<span id="L327" class="LineNr">327 </span>
<span id="L328" class="LineNr">328 </span>user_window_lines
<span id="L329" class="LineNr">329 </span>   the number  of lines <span class="textRainbow_lv0_p0">(</span>rows<span class="textRainbow_lv0_p0">)</span> in  the user i/o window  at the time the
<span id="L330" class="LineNr">330 </span>   user invokes ft_menu_$init <span class="textRainbow_lv0_p0">(</span>which must be the first call to the menu
<span id="L331" class="LineNr">331 </span>   manager in the application<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> Undefined if usage_mode = 0.
<span id="L332" class="LineNr">332 </span>user_window_columns
<span id="L333" class="LineNr">333 </span>   the  number of  columns of  the user  i/o window  when ft_menu_$init
<span id="L334" class="LineNr">334 </span>   invoked.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> Undefined if usage_mode = 0.
<span id="L335" class="LineNr">335 </span>user_window_id
<span id="L336" class="LineNr">336 </span>   window  identifier of  the user  i/o window.   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> Undefined if
<span id="L337" class="LineNr">337 </span>   usage_mode = 0.
<span id="L338" class="LineNr">338 </span>code
<span id="L339" class="LineNr">339 </span>   return code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L340" class="LineNr">340 </span>
<span id="L341" class="LineNr">341 </span>
<span id="L342" class="LineNr">342 </span>:Entry:  list:  03/19/85 ft_menu_$list
<span id="L343" class="LineNr">343 </span>
<span id="L344" class="LineNr">344 </span>
<span id="L345" class="LineNr">345 </span>Function:   Used to  list the menu  object<span class="textRainbow_lv0_p0">(</span>s<span class="textRainbow_lv0_p0">)</span> stored  in value segment.
<span id="L346" class="LineNr">346 </span>The names selected are those that match a user provided string.
<span id="L347" class="LineNr">347 </span>
<span id="L348" class="LineNr">348 </span>
<span id="L349" class="LineNr">349 </span>Syntax:
<span id="L350" class="LineNr">350 </span>   declarations:
<span id="L351" class="LineNr">351 </span>     character*168  dir_name
<span id="L352" class="LineNr">352 </span>     character*32   names_array<span class="textRainbow_lv0_p0">(</span>m1<span class="textRainbow_lv0_p0">)</span>
<span id="L353" class="LineNr">353 </span>     character*32   entry_name
<span id="L354" class="LineNr">354 </span>     character*32   match_string
<span id="L355" class="LineNr">355 </span>     integer        no_of_matches
<span id="L356" class="LineNr">356 </span>     integer        code
<span id="L357" class="LineNr">357 </span>   call ft_menu_$list <span class="textRainbow_lv0_p0">(</span>dir_name<span class="textRainbow_lv0_o0">,</span> entry_name<span class="textRainbow_lv0_o0">,</span> match_string<span class="textRainbow_lv0_o0">,</span>
<span id="L358" class="LineNr">358 </span>        no_of_matches<span class="textRainbow_lv0_o0">,</span> names_array<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>
<span id="L359" class="LineNr">359 </span>
<span id="L360" class="LineNr">360 </span>
<span id="L361" class="LineNr">361 </span>Arguments:
<span id="L362" class="LineNr">362 </span>dir_name
<span id="L363" class="LineNr">363 </span>   pathname of directory containing the menu object.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L364" class="LineNr">364 </span>entry_name
<span id="L365" class="LineNr">365 </span>   entry name of value segment containing the menu object.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The
<span id="L366" class="LineNr">366 </span>   suffix &quot;value&quot; need not be specified.
<span id="L367" class="LineNr">367 </span>match_string
<span id="L368" class="LineNr">368 </span>   a character variable that is to be used as the selection criteria to
<span id="L369" class="LineNr">369 </span>   determine what  menu object, if  any, is contained  in the specified
<span id="L370" class="LineNr">370 </span>   value segment that  match <span class="textRainbow_lv0_p0">(</span>or contain<span class="textRainbow_lv0_p0">)</span> this string.   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If set
<span id="L371" class="LineNr">371 </span>   to space<span class="textRainbow_lv0_p0">(</span>s<span class="textRainbow_lv0_p0">)</span>, all names returned.
<span id="L372" class="LineNr">372 </span>
<span id="L373" class="LineNr">373 </span>
<span id="L374" class="LineNr">374 </span>no_of_matches
<span id="L375" class="LineNr">375 </span>   the number of matches found.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> If none, then is is 0.
<span id="L376" class="LineNr">376 </span>names_array
<span id="L377" class="LineNr">377 </span>   an array, of extent m1.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>  The user should insure that m1 is
<span id="L378" class="LineNr">378 </span>   sufficiently  large  to  contain  all  matches  that  may  be found.
<span id="L379" class="LineNr">379 </span>   Contains  the  names of  all  menu objects,  in the  specified value
<span id="L380" class="LineNr">380 </span>   segment, that match the character string match_string.
<span id="L381" class="LineNr">381 </span>code
<span id="L382" class="LineNr">382 </span>   return code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L383" class="LineNr">383 </span>
<span id="L384" class="LineNr">384 </span>
<span id="L385" class="LineNr">385 </span>:Entry:  retrieve:  03/19/85 ft_menu_$retrieve
<span id="L386" class="LineNr">386 </span>
<span id="L387" class="LineNr">387 </span>
<span id="L388" class="LineNr">388 </span>Function:   Used to  retrieve a menu  object previously  stored via the
<span id="L389" class="LineNr">389 </span>ft_menu_$store.  Once retrieved, the user can reference the menu object
<span id="L390" class="LineNr">390 </span>via the menu identifier <span class="textRainbow_lv0_p0">(</span>menu_id<span class="textRainbow_lv0_p0">)</span>.
<span id="L391" class="LineNr">391 </span>
<span id="L392" class="LineNr">392 </span>
<span id="L393" class="LineNr">393 </span>Syntax:
<span id="L394" class="LineNr">394 </span>   declarations:
<span id="L395" class="LineNr">395 </span>     character*168  dir_name
<span id="L396" class="LineNr">396 </span>     character*32   entry_name
<span id="L397" class="LineNr">397 </span>     character*32   menu_name
<span id="L398" class="LineNr">398 </span>     integer        menu_id
<span id="L399" class="LineNr">399 </span>     integer        code
<span id="L400" class="LineNr">400 </span>   call ft_menu_$retrieve <span class="textRainbow_lv0_p0">(</span>dir_name<span class="textRainbow_lv0_o0">,</span> entry_name<span class="textRainbow_lv0_o0">,</span> menu_name<span class="textRainbow_lv0_o0">,</span> menu_id<span class="textRainbow_lv0_o0">,</span>
<span id="L401" class="LineNr">401 </span>       code<span class="textRainbow_lv0_p0">)</span>
<span id="L402" class="LineNr">402 </span>
<span id="L403" class="LineNr">403 </span>
<span id="L404" class="LineNr">404 </span>Arguments:
<span id="L405" class="LineNr">405 </span>dir_name
<span id="L406" class="LineNr">406 </span>   pathname of the directory containing the menu object.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L407" class="LineNr">407 </span>entry_name
<span id="L408" class="LineNr">408 </span>   entry  name of  value segment  containing menu  object.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The
<span id="L409" class="LineNr">409 </span>   suffix &quot;value&quot; need not be specified.
<span id="L410" class="LineNr">410 </span>menu_name
<span id="L411" class="LineNr">411 </span>   name of the menu object used when the object was stored.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L412" class="LineNr">412 </span>menu_id
<span id="L413" class="LineNr">413 </span>   is the  menu id returned  by the call.   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It is  used as the
<span id="L414" class="LineNr">414 </span>   menu object identifier.
<span id="L415" class="LineNr">415 </span>code
<span id="L416" class="LineNr">416 </span>   return code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L417" class="LineNr">417 </span>
<span id="L418" class="LineNr">418 </span>
<span id="L419" class="LineNr">419 </span>:Entry:  store:  03/19/85 ft_menu_$store
<span id="L420" class="LineNr">420 </span>
<span id="L421" class="LineNr">421 </span>
<span id="L422" class="LineNr">422 </span>Function:  Used to store a menu object in a specified value segment.
<span id="L423" class="LineNr">423 </span>
<span id="L424" class="LineNr">424 </span>
<span id="L425" class="LineNr">425 </span>Syntax:
<span id="L426" class="LineNr">426 </span>   declarations:
<span id="L427" class="LineNr">427 </span>     character*168  dir_name
<span id="L428" class="LineNr">428 </span>     character*32   entry_name
<span id="L429" class="LineNr">429 </span>     character*32   menu_name
<span id="L430" class="LineNr">430 </span>     integer        create_seg
<span id="L431" class="LineNr">431 </span>     integer        menu_id
<span id="L432" class="LineNr">432 </span>     integer        code
<span id="L433" class="LineNr">433 </span>   call ft_menu_$store <span class="textRainbow_lv0_p0">(</span>dir_name<span class="textRainbow_lv0_o0">,</span>entry_name<span class="textRainbow_lv0_o0">,</span> menu_name<span class="textRainbow_lv0_o0">,</span> create_seg<span class="textRainbow_lv0_o0">,</span>
<span id="L434" class="LineNr">434 </span>        menu_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>
<span id="L435" class="LineNr">435 </span>
<span id="L436" class="LineNr">436 </span>
<span id="L437" class="LineNr">437 </span>Arguments:
<span id="L438" class="LineNr">438 </span>dir_name
<span id="L439" class="LineNr">439 </span>   pathname of  directory into which  the menu object is  to be placed.
<span id="L440" class="LineNr">440 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L441" class="LineNr">441 </span>entry_name
<span id="L442" class="LineNr">442 </span>   entry  name of  value segment  into which the  menu object  is to be
<span id="L443" class="LineNr">443 </span>   placed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The suffix &quot;value&quot; need not be specified.
<span id="L444" class="LineNr">444 </span>menu_name
<span id="L445" class="LineNr">445 </span>   it is the name to be assigned to the stored menu object.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L446" class="LineNr">446 </span>
<span id="L447" class="LineNr">447 </span>
<span id="L448" class="LineNr">448 </span>create_seg
<span id="L449" class="LineNr">449 </span>   create_seg  = 0  means do not  store if value  segment identified by
<span id="L450" class="LineNr">450 </span>   entry_name does not already exist.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L451" class="LineNr">451 </span>   create_seg =  1 means create  value segment, if it  does not already
<span id="L452" class="LineNr">452 </span>   exist, and store menu object in it.
<span id="L453" class="LineNr">453 </span>menu_id
<span id="L454" class="LineNr">454 </span>   it is  the menu object  identifier returned when  ft_menu_$create or
<span id="L455" class="LineNr">455 </span>   ft_menu_$retrieve was called.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L456" class="LineNr">456 </span>code
<span id="L457" class="LineNr">457 </span>   return code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L458" class="LineNr">458 </span>
<span id="L459" class="LineNr">459 </span>
<span id="L460" class="LineNr">460 </span>:Entry:  terminate:  03/19/85 ft_menu_$terminate
<span id="L461" class="LineNr">461 </span>
<span id="L462" class="LineNr">462 </span>
<span id="L463" class="LineNr">463 </span>Function:   Must  be the  last call  to  the menu  manager in  the menu
<span id="L464" class="LineNr">464 </span>application.   It  will  remove  the  special  environment  created  by
<span id="L465" class="LineNr">465 </span>ft_menu_$init1 and ft_menu_$init2.
<span id="L466" class="LineNr">466 </span>
<span id="L467" class="LineNr">467 </span>
<span id="L468" class="LineNr">468 </span>Syntax:
<span id="L469" class="LineNr">469 </span>   declarations: none
<span id="L470" class="LineNr">470 </span>   call ft_menu_$terminate <span class="textRainbow_lv0_p0">()</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
